package com.fjhx.tenant.service.dict.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.tenant.entity.dict.dto.DictCommonTypeDto;
import com.fjhx.tenant.entity.dict.dto.DictCommonTypeSelectDto;
import com.fjhx.tenant.entity.dict.po.DictCommonType;
import com.fjhx.tenant.entity.dict.vo.DictCommonTypeVo;
import com.fjhx.tenant.mapper.dict.DictCommonTypeMapper;
import com.fjhx.tenant.service.dict.DictCommonTypeService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 业务字典 服务实现类
 * </p>
 *
 * @author
 * @since 2023-03-30
 */
@Service
public class DictCommonTypeServiceImpl extends ServiceImpl<DictCommonTypeMapper, DictCommonType> implements DictCommonTypeService {

    @Override
    public Page<DictCommonTypeVo> getPage(DictCommonTypeSelectDto dto) {
        IWrapper<DictCommonType> wrapper = getWrapper();
        wrapper.keyword(dto, new SqlField("dct", DictCommonType::getName), new SqlField("dct", DictCommonType::getCode));
        wrapper.eq(DictCommonType::getStatus, dto.getStatus());
        wrapper.orderByDesc("dct", DictCommonType::getId);
        Page<DictCommonTypeVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public DictCommonTypeVo detail(Long id) {
        DictCommonType DictCommonType = this.getById(id);
        DictCommonTypeVo result = BeanUtil.toBean(DictCommonType, DictCommonTypeVo.class);
        return result;
    }

    @Override
    public void add(DictCommonTypeDto dictCommonTypeDto) {
        nameDuplication(DictCommonType::getCode, dictCommonTypeDto.getCode(), "字典编码已存在");
        this.save(dictCommonTypeDto);
    }

    @Override
    public void edit(DictCommonTypeDto dictCommonTypeDto) {
        dictCommonTypeDto.setCode(null);
        this.updateById(dictCommonTypeDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
